#!/usr/bin/fades

import sys
import time

import psutil  # fades

MB = 1024 ** 2

if len(sys.argv) < 2:
    print("Usage: superv_mem.py <exec_name>")
    exit()

superv_exec_name = sys.argv[1]


def get_process():
    for _ in range(20):
        for proc in psutil.process_iter(['pid', 'name']):
            if proc.info['name'] == superv_exec_name:
                print("Found!", proc)
                return proc
        print("Supervised process not found, waiting for it to be started...")
        time.sleep(0.5)

    print("Timeout! Supervised process not found, exiting.")
    exit()


proc = get_process()
max_mem = 0
while proc.is_running():
    current_mem = proc.memory_full_info().uss / MB
    max_mem = max(max_mem, max_mem)
    print("Current: {:.1f} MB".format(current_mem))
    if not proc.is_running():
        break
    time.sleep(3)
print("Peak: {:.1f} MB".format(current_mem))
